var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, h } from './index-64f83f2a.js';
var myComponentCss = "input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=\"number\"]{-moz-appearance:textfield}.emptyDiv{width:100%;height:10%}.flex-container{display:-ms-flexbox;display:flex;-ms-flex-wrap:nowrap;flex-wrap:nowrap;-ms-flex-pack:center;justify-content:center;width:100%}.flex-container>input{width:8px;margin:5px;padding:20px}.otpInput{padding:3px;text-align:center;line-height:25px;font-size:22px;background-color:#ccc}body{display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;-ms-flex-direction:column;flex-direction:column}.digit-group input{width:25px;height:40px;background-color:#18182a;border:none;line-height:50px;text-align:center;font-size:24px;font-family:\"Raleway\", sans-serif;font-weight:200;color:white;margin:0 2px}.digit-group .splitter{padding:0 5px;color:white;font-size:24px}.prompt{margin-bottom:20px;font-size:20px;color:white}.emailMobile{text-align:left}#idk{color:black !important}button{height:38px;width:200px;border-radius:5px !important;border:none;color:black}#emptySpace{width:200px}.buttonsGroup{display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;width:100%;-ms-flex-direction:row;flex-direction:row}.emailandphone{font-size:18px;text-align:left;padding-left:1%}.form-check-input{margin-top:12px}.emailButton{margin:4%;background-color:#007bff;border:none;color:white;padding:6px 32px;text-align:center;text-decoration:none;display:inline-block;font-size:16px}.emptySpace{width:0px}.emailphonecenter{text-align:center}.errormsg{margin-top:2%;color:red}body{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column}*{}.digit-group input{width:40px;height:40px;background-color:silver;border:none;line-height:50px;text-align:center;font-size:24px;font-family:\"Raleway\", sans-serif;margin:0 2px}.digit-group .splitter{padding:0 5px;color:white;font-size:24px}.prompt{margin-bottom:20px;font-size:20px;color:white}.splitter{color:black !important}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=\"number\"]{-moz-appearance:textfield}.emptyDiv{width:100%;height:10%}.flex-container{display:-ms-flexbox;display:flex;-ms-flex-wrap:nowrap;flex-wrap:nowrap;-ms-flex-pack:center;justify-content:center;width:100%;margin-top:3%}.flex-container button{margin-right:50px;margin-left:30px}.flex-container>input{width:80px;margin:5px;padding:20px}.otpInput{padding:3px;text-align:center;line-height:25px;font-size:22px;background-color:#ccc}#backgroundOtp{height:150px}";
var otpcomponent = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.step1_heading = "Identity verification";
        this.step1_headingSP = "Verificación de identidad";
        this.step1_instruction = "Select the information that you can confirm:";
        this.step1_instructionSP = "Seleccione la información que puede confirmar:";
        this.step1_description = "Please take a moment to verify your identity. This helps us confirm your identity and keep your account secured.";
        this.step1_descriptionSP = "Tómese un momento para verificar su identidad. Esto nos ayuda a confirmar su identidad y mantener segura su cuenta.";
        this.step2_heading = "Code verification";
        this.step2_headingSP = "Verificación de código";
        this.toggle = false;
        this.sendOTP = null;
        this.errorMessage = null;
        this.emailList = [];
        this.phoneNoList = [];
        this.redirectTo = false;
        this.otpCode = null;
        this.errorOTP = "";
        this.otpValue = [];
        this.checkToMove = false;
        this.step2_instruction = "Please enter the " + this.size + " digit code below";
        this.step2_instructionSP = "Ingrese el c\u00F3digo de " + this.size + " d\u00EDgitos a continuaci\u00F3n";
    }
    class_1.prototype.parseMyArrayPropTo = function (newValue) {
        if (newValue)
            this.myInnerStrings = JSON.parse(newValue);
    };
    class_1.prototype.componentWillLoad = function () {
        this.parseMyArrayPropTo(this.input);
        for (var i = 0; i < this.myInnerStrings.length; i++) {
            if (this.myInnerStrings[i].includes("@")) {
                this.emailList.push(this.myInnerStrings[i]);
            }
            else {
                this.phoneNoList.push(this.myInnerStrings[i]);
            }
        }
    };
    class_1.prototype.firstPage = function () {
        this.pageFirst();
    };
    class_1.prototype.setValue = function (event) {
        this.sendOTP = JSON.stringify(event.target.value);
    };
    class_1.prototype.check = function () {
        if (this.sendOTP === "" || this.sendOTP === null) {
            if (this.language === "en") {
                this.errorMessage = "Please select your identity";
            }
            else {
                this.errorMessage = "Por favor seleccione su identidad";
            }
        }
        else {
            this.handleOtp();
            this.errorMessage = "";
            this.redirectTo = true;
        }
    };
    class_1.prototype.pageFirst = function () {
        this.redirectTo = false;
    };
    class_1.prototype.handleOtp = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, json, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, fetch(this.api, {
                                headers: {
                                    emailOrMobile: this.sendOTP,
                                },
                            })];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        json = _a.sent();
                        console.log(json);
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        console.log(err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.verifyOTP = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ognum, response, json, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.otpCode === "" || this.otpCode === null)) return [3 /*break*/, 1];
                        if (this.language === "en") {
                            this.errorOTP = "Please enter OTP";
                        }
                        else {
                            this.errorOTP = "Por favor, introduzca OTP";
                        }
                        return [3 /*break*/, 6];
                    case 1:
                        ognum = this.otpValue.join("");
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 6]);
                        return [4 /*yield*/, fetch(this.name, {
                                headers: {
                                    optValue: ognum,
                                },
                            })];
                    case 3:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 4:
                        json = _a.sent();
                        if (json === "Otp Verified 1234") {
                            console.log("Verified ");
                            this.callBack();
                        }
                        else {
                            console.log("NOT Verified MF");
                        }
                        return [3 /*break*/, 6];
                    case 5:
                        err_2 = _a.sent();
                        console.log(err_2);
                        return [3 /*break*/, 6];
                    case 6:
                        this.callBack();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.setOTPValue = function (event) {
        if (this.checkToMove) {
            this.checkToMove = false;
        }
        else {
            this.otpCode = event.target.value;
            var code = event.target.id;
            this.otpValue[code] = event.target.value;
            var hj = parseInt(code);
            var code2 = hj + 1;
            if (code2 <= parseInt(this.size)) {
                document.getElementById("" + code2).focus();
            }
        }
    };
    class_1.prototype.goBack = function () {
        this.redirectTo = false;
    };
    class_1.prototype.maskedEmail = function (emailID) {
        var avg, splitted, part1, part2;
        splitted = emailID.split("@");
        part1 = splitted[0];
        var totalLength = part1.length - 2;
        var hide = "";
        for (var i = 0; i < totalLength; i++) {
            hide = hide + "X";
        }
        avg = part1.substring(0, 2);
        part2 = splitted[1];
        var result = avg + hide + "@" + part2;
        return result;
    };
    class_1.prototype.phoneMasked = function (data) {
        var afterSplit = data.split("-");
        var result = "XXX-XXX-" + afterSplit[2];
        return result;
    };
    class_1.prototype.render = function () {
        var _this = this;
        window.addEventListener("keydown", function (e) {
            if (e.keyCode == 8 || e.keyCode == 46) {
                _this.checkToMove = true;
            }
        });
        var textStyle = {
            color: this.color,
            fontFamily: this.fontfamily,
            fontSize: this.headingfontsize,
            fontWeight: "500",
        };
        var line = {
            borderBottomStyle: "solid",
            borderBottomWidth: "thin",
            borderBottomColor: "#d3d3d3",
            width: "99%",
            marginBottom: "20px",
        };
        var contentStyle = {
            fontFamily: this.fontfamily,
            color: this.color,
            fontSize: this.textfontsize,
        };
        var buttonStyle = {
            backgroundColor: this.color,
            fontFamily: this.fontfamily,
            borderColor: this.color,
            fontSize: this.textfontsize,
        };
        var innerContent = {
            fontFamily: this.fontfamily,
            marginLeft: "10px",
        };
        var inputStyle = {
            border: this.color + " 1.5px solid",
            fontSize: this.textfontsize + " !important",
            fontFamily: this.fontfamily,
        };
        var errorStyle = {
            fontSize: this.textfontsize,
            fontFamily: this.fontfamily,
        };
        var vectorInput = [];
        var num = parseInt(this.size);
        for (var i = 0; i < num; i++) {
            var inName = "" + i;
            if (i === num - 1) {
                vectorInput.push(h("form", { method: "get", class: "digit-group", "data-group-name": "digits", "data-autosubmit": "false", autocomplete: "off" }, h("input", { type: "text", onInput: function (e) { return _this.setOTPValue(e); }, style: inputStyle, id: inName, name: "digit-1", "data-next": "digit-2", maxlength: "1" })));
            }
            else {
                vectorInput.push(h("form", { method: "get", class: "digit-group", "data-group-name": "digits", "data-autosubmit": "false", autocomplete: "off" }, h("input", { type: "text", style: inputStyle, onInput: function (e) { return _this.setOTPValue(e); }, id: inName, name: "digit-1", "data-next": "digit-2", maxlength: "1" }), h("span", { class: "splitter" }, "\u2013")));
            }
        }
        var displayEmail = this.emailList.map(function (value) { return (h("div", { class: value }, h("lab", { htmlFor: value }, h("input", { class: "form-check-input", type: "radio", name: "drone", value: value, onInput: function (e) { return _this.setValue(e); }, style: inputStyle }), _this.maskedEmail(value)))); });
        var displayPhone = this.phoneNoList.map(function (value) { return (h("div", { class: value }, h("lab", { htmlFor: value }, h("input", { class: "form-check-input", type: "radio", name: "drone", value: value, onInput: function (e) { return _this.setValue(e); }, style: inputStyle }), _this.phoneMasked(value)))); });
        return (h("div", null, this.redirectTo === true ? (h("div", null, h("center", null, h("h3", { class: "" }, this.language === "en" ? (h("span", { style: textStyle }, this.step2_heading)) : (h("span", { style: textStyle }, this.step2_headingSP)))), h("div", { class: "lineClass", style: line }), h("center", null, this.language === "en" ? (h("div", { style: contentStyle }, this.step2_instruction)) : (h("div", { style: contentStyle }, this.step2_instructionSP))), h("div", { class: "row mt-4" }, h("div", { class: "flex-container" }, vectorInput)), h("center", { class: "errormsg", style: errorStyle }, this.errorOTP !== null ? h("p", null, this.errorOTP) : null), h("center", null, h("div", { class: "buttonsGroup" }, h("button", { class: "emailButton", style: buttonStyle, onClick: this.goBack.bind(this) }, this.language === "en" ? h("a", null, "Previous") : h("a", null, "Previo")), h("button", { class: "emailButton", style: buttonStyle, onClick: this.verifyOTP.bind(this) }, this.language === "en" ? (h("a", null, "Verify now")) : (h("a", null, "Verifica ahora"))))), h("center", null, h("a", { href: "#", style: contentStyle, onClick: function () { return _this.firstPage(); } }, this.language === "en" ? (h("a", null, "Resend code")) : (h("a", null, "Reenviar codigo")))))) : (h("div", { class: "container mt-5" }, h("center", null, h("h1", { style: textStyle }, this.language === "en" ? (h("span", null, this.step1_heading)) : (h("span", null, this.step1_headingSP)))), h("div", { style: line }), h("center", null, h("div", { class: "text-center", style: contentStyle }, this.language === "en" ? (h("span", null, this.step1_description)) : (h("span", null, this.step1_descriptionSP)))), h("center", null, h("div", { class: "text-center", style: contentStyle }, this.language === "en" ? (h("span", null, this.step1_instruction)) : (h("span", null, this.step1_instructionSP)))), h("center", null, h("div", { class: "flex-container" }, h("div", { class: "emailandphone", style: innerContent }, displayEmail, displayPhone))), h("center", { class: "errormsg" }, this.errorMessage !== "" || this.errorMessage !== null ? (h("p", null, this.errorMessage)) : null), h("center", null, h("div", { class: "buttonsGroup" }, h("button", { class: "emailButton", style: buttonStyle }, this.language === "en" ? (h("span", null, "Previous")) : (h("span", null, "Previo"))), h("button", { class: "emailButton", style: buttonStyle, onClick: this.check.bind(this) }, this.language === "en" ? (h("span", null, "Send OTP")) : (h("span", null, "Enviar OTP"))))), h("center", null, h("a", { style: contentStyle, href: "#" }, this.language === "en" ? (h("span", null, "I don't see my number or email")) : (h("span", null, "No veo mi n\u00FAmero o correo electr\u00F3nico"))))))));
    };
    Object.defineProperty(class_1, "watchers", {
        get: function () {
            return {
                "input": ["parseMyArrayPropTo"]
            };
        },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
otpcomponent.style = myComponentCss;
export { otpcomponent as otp_web_component };
